import 'package:calendar_view/calendar_controller/controller.dart';
import 'package:calendar_view/calendar_page/calendar_left_panel.dart';
import 'package:calendar_view/calendar_page/calendar_main_panel.dart';
import 'package:calendar_view/popup_layer/global_click_listener.dart';
import 'package:calendar_view/popup_layer/popup_layer_controller.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class CalendarPage extends StatefulWidget {
  const CalendarPage({super.key});

  @override
  State<CalendarPage> createState() => _CalendarPageState();
}

class _CalendarPageState extends State<CalendarPage> {
  final PopupLayerController _popupLayerController =
      Get.put<PopupLayerController>(PopupLayerController());
  @override
  void initState() {
    super.initState();
    Get.put<CalendarController>(CalendarController());
  }

  @override
  Widget build(BuildContext context) {
    return GlobalClickListener(
      controller: _popupLayerController,
      child: Row(
        children: const <Widget>[
          CalendarLeftPanel(),
          Expanded(child: CalendarMainPanel()),
        ],
      ),
    );
  }
}
