import 'package:calendar_view/popup_layer/popup_layer_controller.dart';
import 'package:flutter/material.dart';

/// 全局事件监听器，用于搭配popup_layer使用
/// 用于监听全局点击事件，当点击到popup_layer以外的区域时，关闭popup_layer
class GlobalClickListener extends StatelessWidget {
  const GlobalClickListener(
      {Key? key, required this.child, required this.controller})
      : super(key: key);

  final Widget child;
  final PopupLayerController controller;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: (event) {
        controller.onGlobalClick.emit(this, event);
      },
      onPointerUp: (event) {
        controller.onGlobalClick.emit(this, event);
      },
      child: child,
    );
  }
}
