import 'package:calendar_view/utils/calendar_util.dart';
import 'package:calendar_view/utils/event_type.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class PopupLayerController extends GetxController {
  PopupLayerController();

  /// 弹出层【显示更多日程】事件通知
  FEventHandler<GlobalKey> onPopupMoreSchedule = FEventHandler<GlobalKey>();

  /// 弹出层【显示日程详情】事件通知
  FEventHandler<GlobalKey> onPopupScheduleDatail = FEventHandler<GlobalKey>();

  /// 全局点击事件通知
  FEventHandler<PointerEvent> onGlobalClick = FEventHandler<PointerEvent>();

  /// 关闭日程弹窗 事件通知
  FEventHandler<void> onCloseSchedulePopup = FEventHandler<void>();

  /// Popup 弹出层相关的数据
  /// 当前需要显示更多的日程数据
  MonthViewDayStructure currMoreScheduleData = MonthViewDayStructure(
    index: 1,
    date: DateTime.now(),
  );

  // 填充
  //  final String title; // 日程标题
  // final String content; // 日程内容
  // final DateTime day; // 日程日期
  // final ScheduleType type; // 日程类型
  // final DateTime? startTime; // 日程开始时间
  // final DateTime? endTime; // 日程结束时间
  Schedule currScheduleData = Schedule(
    title: 'title',
    content: 'content',
    day: DateTime.now(),
    type: ScheduleType(
      typeName: 'typeName',
      isSelected: true,
      color: Colors.red,
    ),
    startTime: DateTime.now(),
    endTime: DateTime.now(),
  );

  void handlePopupMoreSchedule(
      GlobalKey key, MonthViewDayStructure moreScheduleData) {
    currMoreScheduleData = moreScheduleData;
    onPopupMoreSchedule.emit(this, key);
  }

  void handlePopupScheduleDetail(GlobalKey key, Schedule scheduleData) {
    currScheduleData = scheduleData;
    onPopupScheduleDatail.emit(this, key);
  }

  @override
  void onInit() {
    super.onInit();
  }
}
